' Main.bas
' 1. 本Task為主模块
'检测btn引脚被触发==>模块状态发生改变=> 子模塊执行动作 ==> 动作执行完毕 ==>模块状态改变

'本模块包含3個檔案：
'	1. Main.bas				:主程序
'	2. Main_sub.bas			:動作子程序


'本模块包含6種基本狀態 （其他手動模式可由用戶自行擴展）：
'	Case SysMode_Init	:	当系统处于初始化模式时：		
'							1,允许点击Home按钮使设备进入Home状态
'	Case SysMode_Home 	:	当系统处于Home模式时：
'							1,执行Home动作
'							2,回Home成功切换到手动模式
'	Case SysMode_Ready 	:	当系统处Ready动模式时：
'							1,按下Auto模式按钮且系统处于Ready状态，切换到Auto模式
'							2,按下原点按钮且系统处于Ready状态，切换到Home模式
'							3,允许进行手动动作(标定,轴定位运动等)
'							4,允许切换到暂停模式
'	Case SysMode_Auto	:	当系统处于自动模式时：
'							1,允许进行自动加工流程
'							2,不允许Home
'							3,不允许其他手动动作
'							4,允许切换到暂停模式
'	Case SysMode_Err	:	系统处于异常模式
'							1,设备除了手动Jog不允许其他动作
'							2,排除异常后需进入初始化模式
'	Case SysMode_Pause	:	系统处于暂停模式
'							1,按下暂停恢复按钮,继续执行暂停之前的动作

' 本模块定義的[輸入引腳][輸出引腳]
' 注意：按鈕訊號[輸入引腳]必須 0 -> 1 變化, 才會觸發動作
' btn_home 			: [輸入引腳] 回原點按鈕			
' btn_Mode			: [輸入引腳] 自動/手動模式切換按鈕				
' btn_ClearErr		: [輸入引腳] 清除錯誤按鈕		
' btn_SaveFile		: [輸入引腳] 存檔按鈕		
' btn_Pause			: [輸入引腳] 暫停按鈕		
' btn_Resume		: [輸入引腳] 回復暫停按鈕		
' btn_Stop			: [輸入引腳] 停止按鈕		
' SysMode			: [輸出引腳] 模塊目前在哪個模式


'*******************************************************
'----------------------系统初始化-----------------------
'*******************************************************
actInit_main()	'系统初始化


'*******************************************************
'----------------------进入主循环-----------------------
'*******************************************************
'MS_Loop(10)内的数字表示循环的周期时间
'此循环时间建议再5~10之间.过低的扫描速率可能会导致CPU占用率被提高
MS_LOOP(10)
	
	'第一步：每个周期开始时，先执行扫描方法。
	IF Ms_EdgeR(btn_SaveFile)		Then actFileSave_main()					'1,扫描是否需要保存文件	
	IF Ms_EdgeR(btn_Pause)			Then actPause_main()					'2,扫描是否暂停运动
	IF Ms_EdgeR(btn_Stop)			Then actStop_main()						'3,扫描是否停止运动
	scanErr_main()   														'4,扫描是否出现异常   
	scanIO_main()															'5,扫描IO信号按钮是否触发

	'第二部: 判断系统当前状态
	Select Case CINT(SysMode)
		
		Case SysMode_Init			'按下回原按钮, 切换到HomeMode
			IF btn_Home = 1			Then SysMode = SysMode_Home

		
		Case SysMode_Home 			'执行回原点，完成后切换到ReadyMode
			IF Ms_Pulse(SysMode) 	Then HomeStep 	= 0 				'第一次进入 HomeMode, 将HomeStep清0	
			IF actHome_main() = 1 	Then SysMode 	= SysMode_Ready		'完成切换到Ready模式
		
		
		Case SysMode_Ready 			'按下btn_Auto按钮, 切換到AutoMode
			IF Ms_Pulse(SysMode) 			Then 						'第一次进入手动模式,将自动旗标设为0
				SetAuto_TB		= 0										
			End IF
			
			IF TBMode = TBMode_Ready  Then 	   							'注意！手動動作必須在Ready状态下
				IF Ms_EdgeR(btn_Auto)		Then SysMode = SysMode_Auto	'按下自动按钮,切换到自动模式
				IF Ms_EdgeR(btn_home)		Then SysMode = SysMode_Home	'按下回原按钮,切換到HomeMode
			End IF 

		Case SysMode_Auto			'执行自动运行，按下停止按钮可结束自动运行，进入ReadyMode
			IF Ms_Pulse(SysMode) 			Then 						'第一次进入自动模式,将自动旗标设为1
				SetAuto_TB		= 1										'将左自动运行模块旗标设置为1
			End IF
			
			IF SetAuto_TB		= 0 		Then SysMode 	= SysMode_Ready
			
		Case SysMode_Err			'scanErr_main()发生错误时,会进入此模式
			IF Ms_Pulse(SysMode) 			Then 
				SetStop_TB 	= 1											'发生错误后停止左模块运动
			End IF
			
			If Ms_EdgeR(btn_ClearErr) 		Then 						'按下错误清除按钮
				actErrorClear_main()									'执行恢复清除方法	
				SysMode 	= SysMode_Init								'系统状态设置为初始化模式
				SetInit_TB	= 1
			End If 
		
		Case SysMode_Pause			'actPause_S()发生错误时,会进入此模式
			If btn_Resume	= 1 			Then actResume_main()		'系统处于暂停状态,且按下了恢复按钮，则恢复系统暂停前状态
			
	End Select
MS_LEND
