' ---------------------------------------------------------------------
' ----------------------通用定义--------------------------------------- 
' ---------------------------------------------------------------------

'轴定义
#DEFINE X1					0
#DEFINE Y1					1
#DEFINE Z1					2

'动作流程结束后，返回执行结果
'动作异常结束时,函数本身要对异常进行处理。例如抛出提示信息等
#DEFINE StepDone	999		'动作正常结束：返回999
#DEFINE StepFail	998		'动作异常结束：返回998


' -----------------------------------------------------------------------------
' -------------------------主模块 MainXXX.bas 定义-----------------------------
' -----------------------------------------------------------------------------
'按钮VR
#DEFINE SysMode   			VR(0)		'系统当前模式
	#DEFINE SysMode_Init	0			'处于初始化模式中(需要初始化)
	#DEFINE SysMode_Home 	1			'系统处于Home模式中
	#DEFINE SysMode_Ready	2			'系统处于Ready模式中(等待手动操作)
	#DEFINE SysMode_Auto	3			'系统处于自动运行模式中(等待自动启动信号)
	#DEFINE	SysMode_Pause	4			'系统处于暂停模式中(等待恢复暂停)
	#DEFINE SysMode_Err		5			'系统处于错误模式中(有错误需要处理)

#DEFINE SysErrMsg		VR(1)		'错误信息
	'0:无错误
	'1:轴报警
	'2:轴正极限
	'3:轴负极限
	'4:轴软正极限
	'5:轴软负极限
	'6:轴急停
	'7:MotionRing掉线(EtherCat模式专用)
	'8:IORing掉线(EtherCat模式专用)
		
#DEFINE HomeFlag	 		VR(2)		'系统原点完成信号旗标
#DEFINE HomeStep			VR(3)		'原点模式当前运行步骤
#DEFINE BePause_main		VR(4)		'记录系统暂停前的状态

#DEFINE btn_home			VR(10)
#DEFINE btn_Auto			VR(11)

#DEFINE btn_ClearErr		VR(13)
#DEFINE btn_SaveFile		VR(14)
#DEFINE btn_Pause			VR(15)
#DEFINE btn_Resume			VR(16)
#DEFINE btn_Stop			VR(17)



'声明每个循环都需要扫描的内容,以关键字Scan开头。实现放在Sub_Main.bas
Declare Sub scanErr_main()
Declare Sub scanIO_main()


'动作类的函数，以关键字Act开头。实现放在Sub_Main.bas
Declare Function actInit_main()			as i16
Declare Function actStop_main()			as i16
Declare Function actHome_main()			as i16
Declare Function actPause_main()		as i16
Declare Function actResume_main()		as i16
Declare Function actErrorClear_main()	as i16
Declare Function actFileSave_main()		as i16


'-----------------------------------------------------------------------------
'----------------------示例Table模块 Table_XXX.bas 定義 --------------------------
'-----------------------------------------------------------------------------
#DEFINE TBMode 				VR(100)			'Table模块当前运行模式
	'Table模块 TBMode 模式定義
	#DEFINE TBMode_init			0			'Table模块初始化模式
	#DEFINE TBMode_Ready		1			'Table模块准备模式
	#DEFINE TBMode_Home			2			'Table模块回原点模式
	#DEFINE TBMode_AutoRun		3			'Table模块自动加工模式
	#DEFINE TBMode_Stop 		4			'Table模块停止模式
	#DEFINE TBMode_Pause 		5			'Table模块暂停模式
	#DEFINE TBMode_Resume 		6			'Table模块暂停模式
	
	


#DEFINE TBStep				VR(101)			'Table模块当前运行步骤
#DEFINE AutoStep_TB			VR(102)
#DEFINE BePause_TB			VR(103)			'存储Table模块暂停前状态

#DEFINE SetInit_TB			VR(110)
#DEFINE SetHome_TB			VR(111)
#DEFINE SetPause_TB			VR(112)
#DEFINE SetResume_TB		VR(113)
#DEFINE SetStop_TB			VR(114)
#DEFINE SetAuto_TB			VR(115)



'Table模块动作类的函数声明 -------------------------------
'以关键字Act开头。执行完毕后返回1 。实现放在Slide_Sub.bas
Declare Function  actInit_TB() 		AS I16	 		'滑台初始化
Declare Function  actHome_TB() 		AS I16	 		'滑台Home
Declare Function  actAutoRun_TB()  	AS I16			'滑台自动运行
Declare Function  actStop_TB() 		AS I16			'滑台停止
Declare Function  actPause_TB() 	AS I16	 		'滑台暂停
Declare Function  actResume_TB() 	AS I16			'滑台取消暂停




' ---------------------------------------------------------------------
' ----------------------锁螺丝新增的定义-------------------------------
' ---------------------------------------------------------------------
DIM SHARED as TMR T1						'TMR对象变量, 延迟计数器
DIM SHARED as PT P_Array(4)					'PT变量, 锁付螺丝4个点的位置

Declare Function actWaitPos_TB()	AS I16  '机头到待机位
Declare Function actGetScrew_TB() 	AS I16  '机头取螺丝
Declare Function actDoScrew_TB() 	AS I16  '机头锁螺丝

#DEFINE WaitPosX		VR(1000)     '模塊X等待位置
#DEFINE WaitPosY		VR(1001)     '模塊Y等待位置
#DEFINE WaitPosZ		VR(1002)	 '模塊Z等待位置
#DEFINE GetScrewPosX	VR(1003)	 '模塊X取螺丝位置
#DEFINE GetScrewPosY	VR(1004)	 '模塊Y取螺丝位置
#DEFINE GetScrewPosZ	VR(1005)	 '模塊Z取螺丝位置
#DEFINE ScrewNum		VR(1006)     '模塊锁付的螺丝数量
#DEFINE StartScrewPosZ	VR(1007)     '模塊Z1轴准备开始锁螺丝位
#DEFINE ScrewLen		VR(1008)     '模塊Z1轴锁螺丝的深度



