'====================================>滑台模块说明<======================================
'本模块为独立的任务, 借由[输入引脚]来触发运行
'本模块为独立的任务, 设计内部有状态机，借由[输入引脚]来切换状态
'本模块子模块，包含3個档案：
'	1. Table.bas			:主程序
'	2. Table_sub.bas		:动作子程序，提供給 Table.bas 與 Table_AutoRun 调用
'	3. Table_AutoRun.bas	:自动运行子程序

'本模块负责Table工站的运动动作
'检测引脚被触发 => 模块状态发生改变 => Table执行动作 => 单个动作执行完毕 => 重置引脚信号 =>回到Ready模式

'本模块的[输入/输出]引脚，借由这些引脚来与主模块互动
'	SetHome_TB		: [输入/输出] 原点引脚，输入为1时，触发回原动作; 动作完成后输出0
' 	SetPause_TB		: [输入/输出] 暂停引脚，输入为1时，触发暂停动作; 动作完成后输出0
' 	SetResume_TB	: [输入/输出] 恢复引脚，输入为1时，触发暂停恢复动作; 动作完成后输出0
' 	SetStop_TB		: [输入/输出] 停止引脚，输入为1时，触发停止动作; 动作完成后输出0
' 	SetAuto_TB		: [输入/输出] 自动加工引脚，输入为1时，触发自动加工流程; 动作完成后输出0
' 	SetInit_TB		: [输入/输出] 手动到初始化引脚，输入为1时，触发模块为初始化状态
' 	TBMode			: [输出] 模块目前在哪个模式
' 	TBStep			: [输出] 当前模式下，目前在哪个步骤
' 	AutoStep_TB		: [输出] 自动模式下，目前在哪个步骤     


'本模块包含7种基本状态，可由 TBMode [输出引脚]读取 ：
'	CASE TBMode_init		'初始化模式
'	CASE TBMode_Ready		'待机模式
'	CASE TBMode_Home		'回原模式
'	CASE TBMode_AutoRun		'自动加工模式
'	CASE TBMode_Stop		'停止模式
'	CASE TBMode_Pause		'暂停模式
'	CASE TBMode_Resume 		'恢复模式



'--------------初始化左模块----------
ActInit_TB()


'--------------进入主循环------------
'开始循环
MS_LOOP(10)

	'第一步：每个周期开始时，先扫描停止运动和暂停运动引脚
	IF SetStop_TB	= 1	 Then TBMode	= TBMode_Stop					'循环开始检测是否停止运动
	IF SetPause_TB  = 1	 Then BePause_TB = TBMode						'检测到暂停状态,先备份当前模式
	IF SetPause_TB  = 1	 Then TBMode	= TBMode_Pause					'检测到暂停状态,切换到暂停模式
	
	
	'第二步: 判断左模块当前的状态,执行对应动作
	Select Case Cint(TBMode)
		
		CASE TBMode_init		'初始化状态：收到SetHome_L=1信号，切换到Home模式
			SetInit_TB = 0 
			If SetHome_TB 		= 1		Then TBMode = TBMode_Home		'当原点引脚被触发，设置左工位为原点状态
		
		CASE TBMode_Ready		'待机状态：收到SetAuto_L=1信号，切换AutoRun模式
			If SetHome_TB 		= 1		Then TBMode = TBMode_Home		'模块原点引脚为1,切换状态为原点状态
			IF SetAuto_TB 		= 1		Then TBMode = TBMode_AutoRun	'自动模式引脚为1,切换状态为到自动加工状态
			IF SetInit_TB 		= 1 	Then TBMode = TBMode_init		'初始化模式引脚为1,切换状态为初始化状态
					
		CASE TBMode_Home		'回原状态: 完成后切换到Ready模式
			IF actHome_TB()		= 1		Then 							'执行原点方法
				TBMode 			= TBMode_Ready							'完成后切换到Ready模式
				SetHome_TB 		= 0										'恢复Home引脚
			End IF 							
	
		Case TBMode_AutoRun		'自动加工状态 (如要停止加工, 請下停止指令)
			IF actAutoRun_TB() 	= 1 	Then 							'自动加工方法
				TBMode 			= TBMode_Ready							'完成后恢复为Ready状态
				SetAuto_TB 		= 0										'复位自动加工引脚
			End IF 
			
		Case TBMode_Stop		'停止状态: 完成后切换到Ready模式
			IF actStop_TB() 	= 1 	Then 							'执行停止运动函数
				TBMode 			= TBMode_Ready							'完成后切换到Ready模式
				SetStop_TB 		= 0 									'复位停止引脚
			End IF  
		
		CASE TBMode_Pause		'暂停状态: 完成后切换到Resume模式
			IF actPause_TB()	= 1 	Then 							'执行暂停运动函数
				TBMode 			= TBMode_Resume							'完成后切换到Ready模式
				SetPause_TB 	= 0  									'复位暂停引脚
			End IF 
		
		CASE TBMode_Resume		'暂停复位状态：完成后恢复暂停前的模式
			IF SetResume_TB  	= 1  	Then 							'恢复引脚为1
				actResume_TB()											'执行恢复方法
				SetResume_TB  	= 0										'复位恢复暂停引脚
			End IF 

	End Select
Ms_Lend
